#!/usr/bin/perl -w
use Test::More;
use File::Basename;
use strict;

# compute plan
my @data = <DATA>;
plan tests => scalar @data;

# example: 'La Commission voit que les prix montent.'
my $dir = dirname($0);
my @output = split /\n/, `scripts/forest_convert.pl -f lp -t grammar $dir/forest`;

foreach my $expected_output (@data) {
    chomp $expected_output;
    is(shift @output, $expected_output, "$expected_output");
}


__DATA__
<div align="center"><sub><font color="red">0</font></sub></div><hr /><table width="17cm" cellpadding="0"><tr valign="middle"><td align="left" nowrap="">S<sub><font color="red">0-8</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">extraction</font></td> <td align="center"><font color="blue">- | adjx</font></td></span></tr> <tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">fem</font></td></span></tr> <tr><span><td><font color="green">inv</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">mode</font></td> <td align="center"><font color="blue">indicative</font></td></span></tr> <tr><span><td><font color="green">neg</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">sg</font></td></span></tr> <tr><span><td><font color="green">sat</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">tense</font></td> <td align="center"><font color="blue">present</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>1</td> <td> <-- </td> <td><table><tr><td><font color="green">[subject]</font> 2 <font color="green">[xcomp]</font> 4 <font color="magenta">[v]</font> 3 <font color="green">[S]</font> 5</td></tr></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap="">N2<sub><font color="red">0-2</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">fem</font></td></span></tr> <tr><span><td><font color="green">hum</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">sg</font></td></span></tr> <tr><span><td><font color="green">person</font></td> <td align="center"><font color="blue">3</font></td></span></tr> <tr><span><td><font color="green">sat</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">time</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>2</td> <td> <-- </td> <td><table><tr><td><font color="green">[det]</font> 7 <font color="magenta">[nc]</font> 8</td></tr> <tr><td><font color="green">[det]</font> 7 <font color="magenta">[nc]</font> 10</td></tr></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap=""><font color="magenta">voit/voir:v</font><sub><font color="red">2-3</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">lightverb</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">mode</font></td> <td align="center"><font color="blue">indicative</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">sg</font></td></span></tr> <tr><span><td><font color="green">person</font></td> <td align="center"><font color="blue">3</font></td></span></tr> <tr><span><td><font color="green">tense</font></td> <td align="center"><font color="blue">present</font></td></span></tr></table></td> <td align="left" nowrap=""><font color="blue">119</font></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>3</td> <td> <-- </td> <td><table></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap="">S<sub><font color="red">3-7</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">extraction</font></td> <td align="center"><font color="blue">wh</font></td></span></tr> <tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">masc</font></td></span></tr> <tr><span><td><font color="green">mode</font></td> <td align="center"><font color="blue">indicative</font></td></span></tr> <tr><span><td><font color="green">neg</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">pl</font></td></span></tr> <tr><span><td><font color="green">person</font></td> <td align="center"><font color="blue">3</font></td></span></tr> <tr><span><td><font color="green">sat</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">tense</font></td> <td align="center"><font color="blue">present</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">+</font></td></span></tr></table></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>4</td> <td> <-- </td> <td><table><tr><td><font color="green">[subject]</font> 12 <font color="green">[object]</font> 11 <font color="magenta">[v]</font> 13</td></tr></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap="">S<sub><font color="red">7-8</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">extraction</font></td> <td align="center"><font color="blue">- | adjx</font></td></span></tr> <tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">fem</font></td></span></tr> <tr><span><td><font color="green">inv</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">mode</font></td> <td align="center"><font color="blue">indicative</font></td></span></tr> <tr><span><td><font color="green">neg</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">sg</font></td></span></tr> <tr><span><td><font color="green">person</font></td> <td align="center"><font color="blue">3</font></td></span></tr> <tr><span><td><font color="green">sat</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">tense</font></td> <td align="center"><font color="blue">present</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap="">S<sub><font color="red">8-8</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">extraction</font></td> <td align="center"><font color="blue">@0</font></td></span></tr> <tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">fem</font></td></span></tr> <tr><span><td><font color="green">inv</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">mode</font></td> <td align="center"><font color="blue">indicative</font></td></span></tr> <tr><span><td><font color="green">neg</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">sg</font></td></span></tr> <tr><span><td><font color="green">sat</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">tense</font></td> <td align="center"><font color="blue">present</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""><table><tr><td>5</td> <td> <-- </td> <td><table><tr><td><font color="green">[void]</font> 15</td></tr></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap="">det<sub><font color="red">0-1</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">def</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">det</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">fem</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">sg</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>7</td> <td> <-- </td> <td><table><tr><td><font color="magenta">[det]</font> 17</td></tr></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap=""><font color="magenta">Commission/commission:nc</font><sub><font color="red">1-2</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">def</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">fem</font></td></span></tr> <tr><span><td><font color="green">hum</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">sg</font></td></span></tr> <tr><span><td><font color="green">person</font></td> <td align="center"><font color="blue">3</font></td></span></tr> <tr><span><td><font color="green">time</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""><font color="blue">53</font></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>8</td> <td> <-- </td> <td><table></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap=""><font color="magenta">Commission/commission:nc</font><sub><font color="red">1-2</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">def</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">fem</font></td></span></tr> <tr><span><td><font color="green">hum</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">sg</font></td></span></tr> <tr><span><td><font color="green">person</font></td> <td align="center"><font color="blue">3</font></td></span></tr> <tr><span><td><font color="green">time</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""><font color="blue">53</font></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>10</td> <td> <-- </td> <td><table></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap=""><font color="magenta">que/que?:pri</font><sub><font color="red">3-4</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">case</font></td> <td align="center"><font color="blue">acc</font></td></span></tr></table></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>11</td> <td> <-- </td> <td><table></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap="">N2<sub><font color="red">4-6</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">masc</font></td></span></tr> <tr><span><td><font color="green">hum</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">pl</font></td></span></tr> <tr><span><td><font color="green">person</font></td> <td align="center"><font color="blue">3</font></td></span></tr> <tr><span><td><font color="green">sat</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">time</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>12</td> <td> <-- </td> <td><table><tr><td><font color="green">[det]</font> 19 <font color="magenta">[nc]</font> 20</td></tr></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap=""><font color="magenta">montent/monter:v</font><sub><font color="red">6-7</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">lightverb</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">mode</font></td> <td align="center"><font color="blue">indicative | subjonctive</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">pl</font></td></span></tr> <tr><span><td><font color="green">person</font></td> <td align="center"><font color="blue">3</font></td></span></tr> <tr><span><td><font color="green">tense</font></td> <td align="center"><font color="blue">present</font></td></span></tr></table></td> <td align="left" nowrap=""><font color="blue">112</font></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>13</td> <td> <-- </td> <td><table></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap=""><font color="magenta">./.:_</font><sub><font color="red">7-8</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"></table></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>15</td> <td> <-- </td> <td><table></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap=""><font color="magenta">La/la:det</font><sub><font color="red">0-1</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">def</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">det</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">fem</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">sg</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""><font color="blue">0</font></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>17</td> <td> <-- </td> <td><table></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap="">det<sub><font color="red">4-5</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">def</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">det</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">pl</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>19</td> <td> <-- </td> <td><table><tr><td><font color="magenta">[det]</font> 21</td></tr></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap=""><font color="magenta">prix/prix:nc</font><sub><font color="red">5-6</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">def</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">gender</font></td> <td align="center"><font color="blue">masc</font></td></span></tr> <tr><span><td><font color="green">hum</font></td> <td align="center"><font color="blue">-</font></td></span></tr> <tr><span><td><font color="green">person</font></td> <td align="center"><font color="blue">3</font></td></span></tr> <tr><span><td><font color="green">time</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""><font color="blue">53</font></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>20</td> <td> <-- </td> <td><table></table></td></tr></table></td></tr><tr valign="middle"><td align="left" nowrap=""><font color="magenta">les/les:det</font><sub><font color="red">4-5</font></sub></td> <td align="left" nowrap=""><table align="vcenter" cellpadding="0" border="2"><tr><span><td><font color="green">def</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">det</font></td> <td align="center"><font color="blue">+</font></td></span></tr> <tr><span><td><font color="green">number</font></td> <td align="center"><font color="blue">pl</font></td></span></tr> <tr><span><td><font color="green">wh</font></td> <td align="center"><font color="blue">-</font></td></span></tr></table></td> <td align="left" nowrap=""><font color="blue">0</font></td> <td align="left" nowrap=""></td> <td align="left" nowrap=""><table><tr><td>21</td> <td> <-- </td> <td><table></table></td></tr></table></td></tr></table>
